#!/bin/bash

OPA=$1
SUFFIX=$2

get_abs_filename() {
  # $1 : relative filename
  echo "$(cd "$(dirname "$1")" && pwd)/$(basename "$1")"
}

OPA_DIR=$(dirname $(get_abs_filename $OPA))
OPA_NAME=$(basename $OPA)


# Normal run.
GOMAXPROCS=4 GODEBUG=gctrace=1 /usr/bin/time -v ./$OPA run -s -c $OPA_DIR/config.yaml --pprof > ${SUFFIX}.log 2>&1 &
sleep 1

locust -f abac_locust.py --processes 8 --headless -u 8 -r 8 -t 20s PostUser 2> locust-log-${SUFFIX}.txt
./profile.sh ${SUFFIX}

sleep 1
pkill -SIGINT $OPA_NAME
sleep 1
awk -f summarize-gctrace.awk ${SUFFIX}.log > gctrace-${SUFFIX}.txt

# Gzip run.

GOMAXPROCS=4 GODEBUG=gctrace=1 /usr/bin/time -v ./$OPA run -s -c $OPA_DIR/config.yaml --pprof > ${SUFFIX}-gzip.log 2>&1 &
sleep 1

locust -f abac_locust.py --processes 8 --headless -u 8 -r 8 -t 20s GzipPostUser 2> locust-log-${SUFFIX}-gzip.txt
./profile.sh ${SUFFIX}-gzip

sleep 1
pkill -SIGINT $OPA_NAME
sleep 1
awk -f summarize-gctrace.awk ${SUFFIX}-gzip.log > gctrace-${SUFFIX}-gzip.txt
